/* GtkDockBar and GtkDockBox example.
 *
 * The only thing missing from this example is the restoration of the
 * dock bars to their last docked edge and in their correct order. As
 * I explained in gtkdockbox.h it is easy. I have it working in the
 * original C++ example using a two-dimensional array of dock bar
 * pointers and C++ input/output streams.
 *
 */

#include <stdlib.h>
#include <gtk/gtk.h>
#include "gtkdockbox.h"

GtkWidget*
create_dock_bar1 (GtkPositionType position)
{
  GtkWidget *dock_bar;
  GtkWidget *toolbar;

  toolbar = gtk_toolbar_new ();
  gtk_toolbar_set_orientation  (GTK_TOOLBAR (toolbar), GTK_ORIENTATION_HORIZONTAL);
  gtk_toolbar_set_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_ICONS);
  gtk_toolbar_set_icon_size (GTK_TOOLBAR (toolbar), GTK_ICON_SIZE_SMALL_TOOLBAR);
  gtk_toolbar_insert_stock (GTK_TOOLBAR (toolbar), GTK_STOCK_OPEN, "Open", NULL, NULL, NULL, -1);
  gtk_toolbar_insert_stock (GTK_TOOLBAR (toolbar), GTK_STOCK_SAVE, "Save", NULL, NULL, NULL, -1);
  gtk_toolbar_insert_stock (GTK_TOOLBAR (toolbar), GTK_STOCK_SAVE_AS, "Save As", NULL, NULL, NULL, -1);
  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
  gtk_toolbar_insert_stock (GTK_TOOLBAR (toolbar), GTK_STOCK_CLOSE, "Close", NULL, NULL, NULL, -1);
  gtk_toolbar_insert_stock (GTK_TOOLBAR (toolbar), GTK_STOCK_QUIT, "Open", NULL, NULL, NULL, -1);
  dock_bar = gtk_dock_bar_new (position);
  gtk_container_add (GTK_CONTAINER (dock_bar), toolbar);
  gtk_widget_show (toolbar);
  gtk_signal_connect_object(GTK_OBJECT (dock_bar), "orientation_changed", (GCallback)gtk_toolbar_set_orientation, toolbar);
  return dock_bar;
}

GtkWidget*
create_dock_bar2 (GtkPositionType position)
{
  GtkWidget *dock_bar;
  GtkWidget *toolbar;

  toolbar = gtk_toolbar_new ();
  gtk_toolbar_set_orientation  (GTK_TOOLBAR (toolbar), GTK_ORIENTATION_HORIZONTAL);
  gtk_toolbar_set_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_ICONS);
  gtk_toolbar_set_icon_size (GTK_TOOLBAR (toolbar), GTK_ICON_SIZE_SMALL_TOOLBAR);
  gtk_toolbar_insert_stock (GTK_TOOLBAR (toolbar), GTK_STOCK_QUIT, "Open", NULL, NULL, NULL, -1);
  dock_bar = gtk_dock_bar_new (position);
  gtk_container_add (GTK_CONTAINER (dock_bar), toolbar);
  gtk_widget_show (toolbar);
  gtk_signal_connect_object(GTK_OBJECT (dock_bar), "orientation_changed", (GCallback)gtk_toolbar_set_orientation, toolbar);
  return dock_bar;
}

GtkWidget*
create_dock_bar3 (GtkPositionType position)
{
  GtkWidget *dock_bar;
  GtkWidget *toolbar;

  toolbar = gtk_toolbar_new ();
  gtk_toolbar_set_orientation  (GTK_TOOLBAR (toolbar), GTK_ORIENTATION_HORIZONTAL);
  gtk_toolbar_set_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_ICONS);
  gtk_toolbar_set_icon_size (GTK_TOOLBAR (toolbar), GTK_ICON_SIZE_SMALL_TOOLBAR);
  gtk_toolbar_insert_stock (GTK_TOOLBAR (toolbar), GTK_STOCK_CLOSE, "Close", NULL, NULL, NULL, -1);
  dock_bar = gtk_dock_bar_new (position);
  gtk_container_add (GTK_CONTAINER (dock_bar), toolbar);
  gtk_widget_show (toolbar);
  gtk_signal_connect_object(GTK_OBJECT (dock_bar), "orientation_changed", (GCallback)gtk_toolbar_set_orientation, toolbar);
  return dock_bar;
}


int main ( int   argc,
           char *argv[] )
{
  GtkWidget *window;
  GtkWidget *dock_box;
  GtkWidget *dock_bar;

  gtk_init (&argc, &argv);

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_default_size(GTK_WINDOW (window), 440, 340);

  gtk_window_set_title (GTK_WINDOW (window), "DockBox Test");

  g_signal_connect (G_OBJECT (window), "destroy",
		    G_CALLBACK (exit), NULL);
  
  /* Add dock box */
  dock_box = gtk_dock_box_new ();

  /* Add dock bar */
  dock_bar = create_dock_bar1(GTK_POS_TOP);
  gtk_dock_box_add_dock_bar (GTK_DOCK_BOX(dock_box), GTK_DOCK_BAR (dock_bar));
  dock_bar = create_dock_bar2(GTK_POS_TOP);
  gtk_dock_box_add_dock_bar (GTK_DOCK_BOX(dock_box), GTK_DOCK_BAR (dock_bar));
  dock_bar = create_dock_bar3(GTK_POS_TOP);
  gtk_dock_box_add_dock_bar (GTK_DOCK_BOX(dock_box), GTK_DOCK_BAR (dock_bar));

  gtk_container_add (GTK_CONTAINER (window), dock_box);
  gtk_widget_show (dock_box);

  /* GtkDockBar */

  gtk_widget_show (window);

  gtk_main ();

  return 0;
}

